	TITLE	zadanie1.asm

CR		EQU	0dh

	DOSSEG
	.MODEL	SMALL
	.STACK	100h		;256 - byte stack
	.DATA
Vysledok	DB	'Pocet osmickovych cislic v retazci je: ',5 DUP(?),13,10,'$'
Buffer		DB	2048 DUP(?)		;Buffer
Zadanie	LABEL	BYTE
 DB	13,10
 DB	13,10
 DB	'###########################################################################',13,10
 DB	'#                                                                         #',13,10
 DB	'# ZADANIE CISLO 1:                                                        #',13,10
 DB	'# ================                                                        #',13,10
 DB	'#                                                                         #',13,10                                
 DB	'# Nacitajte z klavesnice retazec znakov ukonceny znakom "noveho riadku".  #',13,10
 DB	'# Nech slovo je postupnost znakov medzi dvoma znakmi "medzera". Urcte     #',13,10
 DB	'# pocet slov reprezentujucich zapis osmickoveho cisla podla syntaxe       #',13,10
 DB	'# jazyka C. Pocet vytlacte osmickovo                                      #',13,10
 DB	'#                                                                         #',13,10
 DB	'#                                                                         #',13,10
 DB	'#                                                                         #',13,10
 DB	'# Vypracoval: Slavomir VESELENAK                                          #',13,10
 DB	'#                                                                         #',13,10
 DB	'###########################################################################',13,10
 DB	13,10
 DB	13,10
 DB	'Zadajte retazec a stlacte <Enter>....',13,10
 DB	'$'
;
FeedLines	LABEL BYTE
	DB	13,10
	DB	13,10
	DB	'$'
;

	.CODE
Start:	mov	ax,@data
	mov	ds,ax		;Inicializacia datoveho segmentu
	mov	ah,9h		;Funkcia cislo 9h
	mov	dx,offset Zadanie
	int	21h

; Nacitanie retazca z prikazoveho riadku pomocou funkcie cislo 1 prerusenia 21h.
	mov	di,0h
NacitajRiadok:
	mov	ah,1		;Funkcia cislo 1 MS DOS-u
	int	21h		;Nacitanie znaku
; V registri al nam vrati kod znaku.
	cmp	al,13		;Nacitali sme Enter?
	jz	Kontrola	;Ak ano ZF (zero flag) = 1 => ideme hladat
				;osmickove cisla
	mov	[Buffer+di],al	;Ulozenie nacitaneho znaku
	inc	di		;Presun na miesto kam sa ulozi dalsi znak
	cmp	di,2048		;Mame este miesto v bufri ?
	jz	Kontrola	;Ak nie ideme hladat cisla
	jmp	NacitajRiadok	;Ideme citat dlasi znak

; Nasleduje analyza udajov, ktore su v bufri pocet najdenych osmickovych
; cisiel budeme zapisovat do registra AX, ale najprv odriadkujeme, aby
; sme nemali problem pri vypise vysledku.

Kontrola:
	mov	ah,9h			;Funkcia cislo 9h
	mov	dx,offset FeedLines	;Odriadkujeme 
	int	21h
; Tu nasleduje samotna analyza
	mov	[Buffer+di],0h		;Urobime z bufra ASCIIZ retazec
	mov	di,0h			;Skok na zaciatok bufra
	mov	ax,0h			;AX - pocitadlo cisiel
Kontrola_1:
	cmp	[Buffer+di],'0'		;Prvy znak je 0 ?
	jz	Kontrola_2
	jmp	Kontrola_3
Kontrola_2:
; Tato cast kontroluje ci znaky v retazci su z intervalu <'0';'7'>
	inc	di
	cmp	[Buffer+di],0h		;Koniec bufra?
	jz	Kontrola_5
	cmp	[Buffer+di],' '		;Koniec retazca?
	jz	Kontrola_6
	cmp	[Buffer+di],'0'
	jb	Kontrola_3		;Ak [Buffer+di] < '0' skoci
	cmp	[Buffer+di],'7'	
	ja	Kontrola_3		;Ak [Buffer+di] > '7' skoci
	jmp	Kontrola_2
Kontrola_3:
; Tato cast je vlastne posun na dalsi retazec v bufri
	cmp	[Buffer+di],0h		;Koniec dat?
	jz	VypisVysledku		;Ak ano vypis vysledku
	cmp	[Buffer+di],' '		;Koniec retazca?
	jz	Kontrola_4		;Ak ano prejdi na dalsi retazec
	inc	di
	jmp	Kontrola_3
Kontrola_4:
	inc	di
	jmp	Kontrola_1
Kontrola_5:
; Zapocitaj posledne osmickove cislo a skoc na vypis
	inc	ax
	jmp	VypisVysledku
Kontrola_6:
; Zapocitaj dalsie osmickove cislo a prejdi na analyzu dalsieho retazca
	inc	ax
	jmp	Kontrola_4

; Po analyze udajov v bufri, mame pocet najdenych osmickovych cisiel
; v registri AX. Obsah registra AX prevedieme na osmickove cislo,
; reprezentovane ASCII retazcom a tento retazec vypiseme na obrazovku

VypisVysledku:
	mov	di,43d		;Index na miesto najnizsej cislice
	mov	dx,ax		;Kopia vysledku
	mov	cx,0h
	mov	bl,5h		;Pocitadlo prevodu
Prevod:
	shr	ax,cl			;Posun doprava
	and	ax,0007h		;Maska
	add	al,'0'			;Prevod na ASCII znak
	mov	[Vysledok+di],al	;Ulozenie znaku
	dec	bl
	jz	Uprava
	dec	di			;Presun na dalsi znak
	mov	ax,dx
	add	cl,3h
	jmp	Prevod

; Po prevedeni vysledku moze vysledok obsahovat nepodstatne nuly. To su
; take, ktore stoja pred cislom (teda nemaju vplyv na jeho hodnotu.
; Zmazane budu vsetky okrem jednej pre zachovanie syntaxe pre osmickove
; cisla z jazyka C.

Uprava:	mov	bl,4h
	inc	di
Uprava_1:
	cmp	[Vysledok+di],'0'
	jnz	VypisVysledku_1
	mov	[Vysledok+di-1h],' '
	inc	di
	dec	bl
	jnz	Uprava_1

; Uprava bola ukoncena. Nasleduje vypis vysledku.
; Pomocou funkcie cislo 9h prerusenia 21h.
VypisVysledku_1:
	mov	ah,9h			;Funkcia cislo 9h
	mov	dx,offset Vysledok
	int	21h

; Uz nam ostava len ukoncit beh programu
	mov	ax,4c00h		;Funkcia 4ch
	int	21h
END	Start